#ifndef SPLINE_H
#define SPLINE_H
/* Generic header for spline modules */

#include "frame.h"
#ifdef SplinePatch

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include "config.h"

#define LINEAR_SPLINE    1
#define QUADRATIC_SPLINE 2
#define CUBIC_SPLINE     3

SPLINE2 * Create_Spline(int Type);
SPLINE2 * Copy_Spline(SPLINE2 * Old);
void Destroy_Spline(SPLINE2 * Spline);
void Insert_Spline_Entry(SPLINE2 * Spline, DBL p, EXPRESS v);
DBL Get_Spline_Val(SPLINE2 * sp, DBL p, VECTOR v);

#endif
#endif



